	var selected_city, selected_city_id;
	var raw_cities;

	// Handling city search
	var xmlHTTP = new ActiveXObject("Microsoft.XMLHTTP");

	var player = new ActiveXObject("WMPlayer.OCX.7");

	function sortingFunc(a, b){
		//	return a-b; if a<b => -ve, a=b => 0, a>b => +ve
		var temp1 = a.split("|||");
		var temp2 = b.split("|||");
		return (temp1[1]-temp2[1]);
	}

	function init() {
		// Initialize the fields in the dialog box

		// Initialize the fields in the Location tab
		Country = System.Gadget.Settings.readString("SavedCountry");
		selectOptionInList(document.all.elsewhere_country,Country);
		selected_city = System.Gadget.Settings.readString("SavedCity");
		selected_city_id = System.Gadget.Settings.readString("SavedCityID");		
		document.getElementById("selectedcity").innerHTML = "<br><b>Selected City: " + selected_city + " in " + Country.replace(/_/g," ") + "</b>";
		
		// Initialize the Time Zones.
		var collTimeZones = System.Time.timeZones; 
		var tzs = new Array();
		for(i=0;i<collTimeZones.count;i++){
			var oMyTimeZone = collTimeZones.item(i);
			var strName = oMyTimeZone.displayName;
			var bias = oMyTimeZone.bias / -60;
			tzs[i] =  strName + "|||" + bias;
		}
		tzs.sort(sortingFunc);
		for(i=0;i<tzs.length;i++){
			var opt = tzs[i].split("|||");
			document.getElementById("timeZone").options[i] = new Option(opt[0], opt[1]);
		}
		

		if(System.Gadget.Settings.readString("UseCustomLocation") == 'True'){
			document.getElementById("cityDetails").style.display = 'none';
			document.getElementById("customLocation").style.display = '';
			
			var temp = System.Gadget.Settings.readString("Latitude");
			lat.value = Math.abs(temp);
			if(lat.value != temp) selectOptionInList(document.all.latType, 'S');
			else selectOptionInList(document.all.latType, 'N');
			
			temp = System.Gadget.Settings.readString("Longitude");
			long.value = Math.abs(temp); 
			if(long.value != temp) selectOptionInList(document.all.longType, 'W');	
			else selectOptionInList(document.all.longType, 'E');

			selectOptionInList(document.all.timeZone, System.Gadget.Settings.readString("TimeZone"));
			daylightSaving.checked = (System.Gadget.Settings.readString("DaylightSaving") == 'True');
		}
		
		// Initialize the fields in the Calculation tab
		selectOptionInList(document.all.calc_method, System.Gadget.Settings.readString("SavedCalcMethod"));
		selectOptionInList(document.all.mazhab, System.Gadget.Settings.readString("SavedMazhab"));
		selectOptionInList(document.all.hijriAdjustment, System.Gadget.Settings.readString("HijriAdjustment"));
		updateCalcInfo();
		
		// Initialize the fields in the Azan tab
		selectedAzanFile = System.Gadget.Settings.readString("AzanFile");
		selectedFajrAzanFile = System.Gadget.Settings.readString("FajrAzanFile");
		initAzanOption();
		
		selectOptionInList(document.getElementById("azanVolume"), System.Gadget.Settings.readString("AzanVolume"));
		
		document.getElementById("enableAlarms").checked = (System.Gadget.Settings.readString("AlarmsEnbled") == "True");

		var i;
		for(i=0;i<6;i++){
			if(i!=1){
				document.getElementById("EnableAzan"+i).checked = (System.Gadget.Settings.readString("Prayer"+i+"_Azan_Enabled") == "True");
				selectOptionInList(document.getElementById("BeforeAlarm"+i), System.Gadget.Settings.readString("Prayer"+i+"_Before_Alarm"));
				selectOptionInList(document.getElementById("AfterAlarm"+i), System.Gadget.Settings.readString("Prayer"+i+"_After_Alarm"));
			}
		}

		document.getElementById("morningAzkar").checked = (System.Gadget.Settings.readString("Morning_Azkar_Enabled") == "True");
		document.getElementById("morningAzkar").disabled = (document.getElementById("AfterAlarm0").value == -1);
		document.getElementById("eveningAzkar").checked = (System.Gadget.Settings.readString("Evening_Azkar_Enabled") == "True");
		document.getElementById("eveningAzkar").disabled = (document.getElementById("AfterAlarm3").value == -1);
		// Disable alarms if needed.
		toggleAlarms();
		//Initialize the version in the About tab		
		document.getElementById("prayertimesVersion").innerText = System.Gadget.version;
		
		// Show location tab only.
		showTab('loc');
	}

	System.Gadget.onSettingsClosing = function(event)
	{
 		if (event.closeAction == event.Action.commit) {
 			// Country, City, CalcMethod, Mazhab
 			Country = elsewhere_country.value;
 			City = selected_city;
 			CityID = selected_city_id;

			System.Gadget.Settings.writeString("SavedCity", City);
			System.Gadget.Settings.writeString("SavedCityID", CityID);
			System.Gadget.Settings.writeString("SavedCountry", Country);
			
			System.Gadget.Settings.writeString("UseCustomLocation", (Country == 'custom'));
			var temp = lat.value; if(latType.value == 'S') temp = temp * -1;
			System.Gadget.Settings.writeString("Latitude", temp);
			temp = long.value; if(longType.value == 'W') temp = temp * -1;			
			System.Gadget.Settings.writeString("Longitude", temp);
			System.Gadget.Settings.writeString("TimeZone", timeZone.value);
			System.Gadget.Settings.writeString("DaylightSaving", daylightSaving.checked);
			
			System.Gadget.Settings.writeString("SavedCalcMethod", calc_method.value);
			System.Gadget.Settings.writeString("SavedMazhab", mazhab.value);
			System.Gadget.Settings.writeString("HijriAdjustment", hijriAdjustment.value);
			
			System.Gadget.Settings.writeString("AzanFile", selectedAzanFile);
			System.Gadget.Settings.writeString("FajrAzanFile", selectedFajrAzanFile);
			System.Gadget.Settings.writeString("AzanOption", azanOptions.value);
			System.Gadget.Settings.writeString("AzanVolume", azanVolume.value);
			
			System.Gadget.Settings.writeString("AlarmsEnbled", enableAlarms.checked);
	
			for(i=0;i<6;i++){
				if(i!=1){
					System.Gadget.Settings.writeString("Prayer"+i+"_Azan_Enabled", document.getElementById("EnableAzan"+i).checked);
					System.Gadget.Settings.writeString("Prayer"+i+"_Before_Alarm", document.getElementById("BeforeAlarm"+i).value);
					System.Gadget.Settings.writeString("Prayer"+i+"_After_Alarm", document.getElementById("AfterAlarm"+i).value);
				}
			}
			
			System.Gadget.Settings.writeString("Morning_Azkar_Enabled", document.getElementById("morningAzkar").checked);
			System.Gadget.Settings.writeString("Evening_Azkar_Enabled", document.getElementById("eveningAzkar").checked);
			
			event.cancel = false;										
			
		}else if(event.closeAction == event.Action.cancel) {
			event.cancel = true;	
		}	

	}


function showTab(tab){
	resetAllTabs();
	document.getElementById(tab+'_tab').className='selected';
	document.getElementById(tab+'_content').style.display='';
}

function resetAllTabs(){
	var sections = new Array('loc', 'calc', 'azan', 'alarms', 'about');
	
	for(i=0;i<sections.length;i++){
		document.getElementById(sections[i]+'_content').style.display='none';
		document.getElementById(sections[i]+'_tab').className='';
	}
}

function selectOptionInList(list, option){
	for(i=0;i<list.options.length;i++){
		if(list.options[i].value == option){
			list.selectedIndex = i;
			break;
		}
	}
}

function searchCities(){
	var country = document.getElementById("elsewhere_country").value; //alert(country);
	var city = document.getElementById("elsewhere_city").value; //alert(city);
	
	if(city.length >= 2){
		document.getElementById("elsewhere_msg").innerHTML = "<img src=../images/wait.gif align=left> Please wait while data is retrieved."; 
		try{
	  		xmlHTTP.open("GET", "http://www.loayassaf.com/PrayerTimes/getCities.php5?country=" + country + "&city=" + city, true);
			xmlHTTP.onreadystatechange = checkCities;
  			xmlHTTP.send(null);
		} catch (err){
			document.getElementById("elsewhere_msg").innerHTML = "<font color=red>Error! Cannot connect to the Internet!</font>";	
		}
	}else{
		document.getElementById("elsewhere_msg").innerHTML = "<font color=red>Please type at least 2 letters!</font>";
	}
}

function checkCities(){
	if(xmlHTTP.readyState == 4){
		var result = xmlHTTP.responseText;		
		raw_cities = result.split("|");
		document.getElementById("elsewhere_city_list").options.length = 0;
		if(raw_cities.length > 1){
			document.getElementById("elsewhere_city").style.display = 'none';
			document.getElementById("elsewhere_city_search").style.display = 'none';
			for(i=0;i<raw_cities.length-1;i++){
				var option = raw_cities[i].split(":");
				document.getElementById("elsewhere_city_list").options[i] = new Option(option[1], option[0]);
			}
			document.getElementById("elsewhere_city_list").selectedIndex = 0; // preselect the first entry;
			selectCity();

			document.getElementById("elsewhere_city_list").style.display = '';
			document.getElementById("elsewhere_city_list").focus();		
			document.getElementById("elsewhere_city_reset").style.display = '';
			document.getElementById("elsewhere_msg").innerHTML = "Done! " + (raw_cities.length-1) + " cities were retrieved.";
		}else{
			document.getElementById("elsewhere_msg").innerHTML = "<font color=red>Can't find a city that matches your input!</font>";
		}
	}
}

function resetCities(){
	if(document.getElementById("elsewhere_country").value != 'custom'){
		document.getElementById("cityDetails").style.display = '';
		document.getElementById("customLocation").style.display = 'none';
		
		document.getElementById("elsewhere_city").style.fontStyle='italic';
		document.getElementById("elsewhere_city").value = 'Search for city';
		document.getElementById("elsewhere_city").style.color='gray';
		

		document.getElementById("elsewhere_city_list").style.display = 'none';
		document.getElementById("elsewhere_city_reset").style.display = 'none';
		document.getElementById("elsewhere_city").style.display = '';
		document.getElementById("elsewhere_city_search").style.display = '';
		document.getElementById("elsewhere_msg").innerHTML = "Type at least 2 letters and hit 'Search'";
	}else{
		document.getElementById("cityDetails").style.display = 'none';
		document.getElementById("customLocation").style.display = '';
	}
}

function selectCity(){
	selected_city_id = document.getElementById("elsewhere_city_list").value;
	selected_city = document.getElementById("elsewhere_city_list").options[document.getElementById("elsewhere_city_list").selectedIndex].innerText;
	document.getElementById("selectedcity").innerHTML = "<br><b>Selected City: " + selected_city + " in " + document.getElementById("elsewhere_country").value.replace(/_/g," ") +  "</b>";
}

function playSound(){
	stopSound();
	if(player){
		player.settings.Volume = azanVolume.value;
		player.URL = selectedAzanFile;
		player.controls.play();
		hideElement("playButton");
		stopButton.src = "/images/wait.gif"; 
		setTimeout("stopButton.src=\"/images/stop.gif\";", 1000*5);
		showElement("stopButton");
	}
}

function stopSound(){
	if(player){
		player.controls.stop();
		hideElement("stopButton");
		showElement("playButton");
	}
}

function selectAzanOption(){	
	if(azanOptions.value == 'custom'){
		if(System.Gadget.Settings.readString("AzanOption") == 'custom'){
			document.getElementById("customAzanFile").value = selectedAzanFile;
			document.getElementById("customFajrAzanFile").value = selectedFajrAzanFile;
		}
		showElement('customAzan');
		hideElement('playerCtrl');
	}else if(azanOptions.value == 'random'){
		hideElement('customAzan');		
		hideElement('playerCtrl');
	}else{
		hideElement('customAzan');
		showElement('playerCtrl');
		showElement("playButton");
		hideElement("stopButton");
		selectedAzanFile = 'http://www.loayassaf.com/PrayerTimes/getMedia.php5?file=' + azanOptions.value;
		selectedFajrAzanFile = 'http://www.loayassaf.com/PrayerTimes/getMedia.php5?file=' + azanOptions.value + 'fajr';
	}
	stopSound();
}

function initAzanOption(){
	if(System.Gadget.Settings.readString("AzanOption") == 'custom'){
		document.getElementById("customAzanFile").value = selectedAzanFile;
		document.getElementById("customFajrAzanFile").value = selectedFajrAzanFile;
		showElement('customAzan');
		hideElement('playerCtrl');
		//hideElement('stopButton');
	}else if(System.Gadget.Settings.readString("AzanOption") == 'random'){
		hideElement('customAzan');
		hideElement('playerCtrl');
		//hideElement('stopButton');
	}else{
		hideElement('customAzan');
		showElement("playerCtrl");
		showElement('playButton');
		hideElement('stopButton');
	}
	selectOptionInList(document.all.azanOptions, System.Gadget.Settings.readString("AzanOption"));
	stopSound();
}

function playCustomFajrSound(){
	stopCustomSound();
	stopCustomFajrSound();
	if(player && customFajrAzanFile.value != ''){
		player.settings.Volume = azanVolume.value;
		player.URL = customFajrAzanFile.value;
		player.controls.play();
		hideElement("playCustomFajr");
		showElement("stopCustomFajr");
	}
}

function playCustomSound(){
	stopCustomSound();
	stopCustomFajrSound();
	if(player && customAzanFile.value != ''){
		player.settings.Volume = azanVolume.value;
		player.URL = customAzanFile.value;
		player.controls.play();
		hideElement("playCustom");
		showElement("stopCustom");
	}
}

function stopCustomFajrSound(){
	if(player){
		player.controls.stop();
		hideElement("stopCustomFajr");
		showElement("playCustomFajr");
	}
}

function stopCustomSound(){
	if(player){
		player.controls.stop();
		hideElement("stopCustom");
		showElement("playCustom");
	}
}

function updateCustomFajrAzan(){
	var v = customFajrAzanFile.value;
	v = v.replace(/\\/g, '/');
	var file = v.substring(v.lastIndexOf("/")+1);
	//customFajrAzanFileDisplay.innerHTML = file;
}

function updateCustomAzan(){
	var v = customAzanFile.value;
	v = v.replace(/\\/g, '/');
	var file = v.substring(v.lastIndexOf("/")+1);
	//customAzanFileDisplay.innerHTML = file;	
}

function updateCustomAzanDisplay(field, fullpath){
	v = fullpath.replace(/\\/g, '/');
	var file = v.substring(v.lastIndexOf("/")+1);
	document.getElementById(field).innerHTML = file;
}

function CloseCustomAzan(){
	var error = false;
	if(!validFile(customAzanFile.value)){
		otherPrayerFileError.innerText = " Please select a valid file.";
		error = true;
	} else {
		otherPrayerFileError.innerText = "";	
	}
	
	if(!validFile(customFajrAzanFile.value)){
		fajrPrayerFileError.innerText = " Please select a valid file.";
		error = true;
	} else {
		fajrPrayerFileError.innerText = "";	
	}
	
	if(!error){	
		selectedAzanFile = customAzanFile.value;
		selectedFajrAzanFile = customFajrAzanFile.value;
		
		stopCustomSound();
		stopCustomFajrSound();
		hideElement("customAzan");
	}
}

function CancelCustomAzan(){
	stopCustomSound();
	stopCustomFajrSound();	
	hideElement("customAzan");
	//customFajrAzanFileDisplay.innerHTML = originalFajrAzan;
	//customAzanFileDisplay.innerHTML = originalAzan;
	customAzanFile.value = '';
	customFajrAzanFile.value = '';		
}

function validFile(f){
	//f = "C:\\Users\\Loay Assaf\\AppData\\Local\\Microsoft\\Windows Sidebar\\Gadgets\\PrayerTimes.gadget\\includes\\settings.css";
	try{
		var file = System.Shell.itemFromPath(f);
		var x = file.type;
		return true;
	} catch(e){
		return false;
	}
}

function showElement(x){
	document.getElementById(x).style.display = '';
}

function hideElement(x){
	document.getElementById(x).style.display = 'none';
}

function selectFile(v){
	var file = System.Shell.chooseFile(true, "WMA File:*.wma:MP3 File:*.mp3:WAV File:*.wav::",'','');
	document.getElementById(v).value = file.path;
	//updateCustomAzanDisplay(v+'Display', file.path);
}

function toggleAlarms(){
	for(i=0;i<6;i++){
		if(i!=1){
			document.getElementById("BeforeAlarm"+i).disabled = !enableAlarms.checked;
			document.getElementById("AfterAlarm"+ i).disabled = !enableAlarms.checked;
		}
	}
	document.getElementById("morningAzkar").disabled = !enableAlarms.checked;
	document.getElementById("eveningAzkar").disabled = !enableAlarms.checked;	
}

function updateCalcInfo(){
	var txt = "Select a Calculation Method.";
	switch(document.getElementById("calc_method").value){
		case "": //Automatic
			txt = "Automatic based on your location"
			break;
		case "2": //Egyptian General Authority of Survey
			txt = "Used in Africa, Syria, Iraq, Lebanon & Malaysia";
			break;
		case "5": //Islamic Society of North America
			txt = "Used in parts of USA, Canada & UK";
			break;
		case "1": //Muslim World League
			txt = "Used in Europe, Far East & parts of USA";
			break;
		case "4": //Umm Al-Qura University
			txt = "Used in Arabian Peninsula";
			break;
		case "3": //University of Islamic Sciences, Karachi
			txt = "Used in Pakistan, Bangladesh, India, Afganistan & parts of Europe";
	}
	
	document.getElementById("CalcInfo").innerHTML = txt;
}

function showSection(section){
	if(section != 'predefinedAzans'){
		document.getElementById('customAzans').style.display = '';
		document.getElementById('predefinedAzans').style.display = 'none';
	}else{
		document.getElementById('customAzans').style.display = 'none';
		document.getElementById('predefinedAzans').style.display = '';
	}
}