var city, state, country, calcmethod, mazhab;
var lastEmphasized = -1;
var lastAzanPlayed = -1;
var timeRemaining;
var currentWaitTimeIndex = 0;
var currentProgress = 0;
var currentIndex = 0;
var FajrNextDay = false;
var waitTimes = Array(10*60, 10*60, 10*60, 10*60, 5*60, 3*60, 60, 20, 10);
var prayerNames = Array("Fajr", "Sunrise", "Duhr", "Asr", "Maghrib", "Isha");
	var remainingTimeColors = new Array("#00FF00","#00FF00","#00FF00","#00FF00","#00FF00","#00FF00","#33FF00","#66FF00","#99FF00","#CCFF00","#FFFF00","#FFCC00","#FF9900","#FF6600","#FF3300","#FF0000");
var showAlarm = true;
// Stores the prayer times
var prayers = null;

var xmlHttp = new ActiveXObject("Microsoft.XMLHTTP");
var player = new ActiveXObject("WMPlayer.OCX.7");

System.Gadget.settingsUI = "Settings.htm";


//////////////////////////////////////////////////////////
var toggleTimer;

function startToggling(){
	clearTimeout(toggleTimer);
	var waitTime = 10;
	if(msg.style.display == 'none'){
		if(mainPage.style.display == 'none'){
			mainPage.style.display = '';
			page2.style.display = 'none';
			waitTime = parseInt(waitTimes[currentWaitTimeIndex]);
		}else{
			mainPage.style.display = 'none';
			page2.style.display = '';
			waitTime = 5;
		}
	}
	toggleTimer = setTimeout("startToggling()", 1000*waitTime);
}

// Called when the gadget is loaded.
function init(){
	
	if(System.Gadget.Settings.readString("SavedMazhab") == ''){
		System.Gadget.Settings.writeString("SavedCity", "Boston, MA");
		System.Gadget.Settings.writeString("SavedCityID", "620");
		System.Gadget.Settings.writeString("SavedCountry", "USA");
		
		System.Gadget.Settings.writeString("SavedCalcMethod", "");
		System.Gadget.Settings.writeString("SavedMazhab", "1");
		System.Gadget.Settings.writeString("HijriAdjustment", "0");
		
		System.Gadget.Settings.writeString("AzanOption", "random");		
		System.Gadget.Settings.writeString("AzanFile", "http://www.loayassaf.com/PrayerTimes/getMedia.php5?file=random");
		System.Gadget.Settings.writeString("FajrAzanFile", "http://www.loayassaf.com/PrayerTimes/getMedia.php5?file=randomfajr");
		System.Gadget.Settings.writeString("AzanVolume","50");

		for(i=0;i<6;i++){
			if(i!=1){
				System.Gadget.Settings.writeString("Prayer"+i+"_Azan_Enabled", true);
				System.Gadget.Settings.writeString("Prayer"+i+"_Before_Alarm", 15);
				System.Gadget.Settings.writeString("Prayer"+i+"_After_Alarm", 15);
			}
		}

		System.Gadget.Settings.writeString("Morning_Azkar_Enabled", true);
		System.Gadget.Settings.writeString("Evening_Azkar_Enabled", true);
		System.Gadget.Settings.writeString("AlarmsEnbled", true);
		
		displayMessage("Thank you for choosing <b>Prayer Times</b>.<br><br>Please configure it first.");
	} else {
		RefreshPrayerTimes();	// Get the latest prayer times and refresh the display
	}
}

// Define the "trim" function for Strings
String.prototype.trim = function() { return this.replace(/^\s+|\s+$/g, ""); };

// Retrieves the prayer times for the current zipcode and updates the display
function RefreshPrayerTimes(){
	var verMsg = checkLatestVersion();
	if(verMsg != null){
		displayMessage(verMsg);
		return;
	}
		
	// Get the settings
	if(System.Gadget.Settings.readString("UseCustomLocation") == 'True') useLatLong = 1;
	else useLatLong = 0;
	
	if(useLatLong){
		lat = System.Gadget.Settings.readString("Latitude");
		long = System.Gadget.Settings.readString("Longitude");
		tz = System.Gadget.Settings.readString("TimeZone");
		if(System.Gadget.Settings.readString("DaylightSaving") == 'True') dl = 1;
		else dl = 0;
		country = '';
		city = '';
		state = '';
		city_id = '';
	}else{
		country = (System.Gadget.Settings.readString("SavedCountry"));
		city = (System.Gadget.Settings.readString("SavedCity"));
		if(city.indexOf(",") > 0){ // city contains city name and state. i.e. Boston, MA
			// breakdown city into city and state.
			var temp = city.split(",");
			city = temp[0].trim();
			state = temp[1].trim();
		}else{
			state = '';
		}
		// Replace space with underscore
		city = city.replace(" ","_");
		state = state.replace(" ","_");
		country = country.replace(" ","_");
		city_id = (System.Gadget.Settings.readString("SavedCityID"));
		lat = 0;
		long = 0;
		tz = 0;
		dl = 0;
	}
		calcmethod = (System.Gadget.Settings.readString("SavedCalcMethod"));
		mazhab = (System.Gadget.Settings.readString("SavedMazhab"));

	// long, lat, timezone and daylightsaving are for future enhancement
	url = "http://www.loayassaf.com/PrayerTimes/getPrayerTimes3.php5?username="+System.Environment.getEnvironmentVariable("USERNAME")+"&domainname="+System.Environment.getEnvironmentVariable("USERDOMAIN")+"&computername="+System.Environment.getEnvironmentVariable("COMPUTERNAME")+"&ptversion="+System.Gadget.version+"&country=" + country +"&city=" + city + "&cityid=" + city_id + "&state=" + state + "&zipcode=&Mazhab=" + mazhab + "&CalcMethod=" + calcmethod +"&long=" + long + "&lat=" + lat + "&timezone=" + tz + "&daylightsaving=" + dl + "&useLatLong=" + useLatLong;

	try{
		xmlHttp.open("GET", url, true);
		xmlHttp.onreadystatechange = checkPrayerTimes;
		xmlHttp.send(null);		
	} catch(err){
		displayMessage("<font color=red><b>Error!</b></font><br><br>Service not available!");
	}

	setTimeout("RefreshPrayerTimes()", 1000*60*60); // Refresh times every hour
}

function checkPrayerTimes(){
	if(xmlHttp.readyState == 4){
		var result = xmlHttp.responseText;
		//displayMessage(result); return;
		temp_prayers = result.split("-");
		if(temp_prayers.length >= 6){
			document.getElementById("prayertimes").style.display = ''; // Show the prayertimes table.
			document.getElementById("msg").style.display = 'none'; // Hide error message

			document.getElementById("location").innerHTML = formatLocation(city, state, country);
			for(i=0;i<6;i++){
				document.getElementById( ("prayer"+i) ).innerHTML = temp_prayers[i];
			}
			
			setHijriDate(temp_prayers[6]);
			setQibla(temp_prayers[7]);
			
			prayers = temp_prayers;
			
			document.getElementById("mainPage").style.display = '';
			setTimeout("startToggling()", 10*1000);
			doPeriodicCheck();
		}else{
			if(!isArray(prayers)){
				// Error!
				displayMessage("<font color=red><b>Error!</b></font><br><br>Cannot get prayer times for the current location.<br>Try different settings.");
				prayers = null;
			}
		}
	}
}

function isArray() {
	if (typeof arguments[0] == 'object') {  
		var criterion = arguments[0].constructor.toString().match(/array/i);
		return (criterion != null);  
	}
	return false;
}
	
// Reads the new zipcode from the sittings page and triggers RefreshPrayerTimes()
System.Gadget.onSettingsClosed = function () {
	displayMessage("<br>Refreshing prayer times...");
	RefreshPrayerTimes();
//	setTimeout("RefreshPrayerTimes()", 500);
}

//Checks for the latest version, displays the appropriate message if there is one, and return ture if new version is avialable.
function checkLatestVersion(){
	url = "http://www.loayassaf.com/PrayerTimes/getLatestVersion.php5";
	try{
		xmlHttp.open("GET", url, false);
		xmlHttp.send();
		var result = xmlHttp.responseText;

		versionInfo = result.split("|");
		upgradeRequired = (versionInfo[1] == "M");
		upgradeURL = versionInfo[2];
		optionalUpgradeEnabled = true; // for now, it's always true. We'll make it configurable later.
		var msg = "";
		
		if(System.Gadget.Settings.readString("SkipVersion") != versionInfo[0]){	
			if(isOldVersion(System.Gadget.version, versionInfo[0])){
				if(upgradeRequired){
					msg = "A new version is available. You must upgrade now.<br>Remember to close this gadget before you upgrade.";
				}else if(optionalUpgradeEnabled){
					msg = "A new optional version is available.<br>Remember to close this gadget before you upgrade.";
				}
				
				if(msg != ''){
					if(upgradeURL != ''){
						msg += "<br><a style=\"color:#66ccff;;text-decoration:none\" target=\"_blank\" href=\""+upgradeURL+"\">Download it now!</a>";	
					}
					
					if(!upgradeRequired){
							msg += "or <span onclick=\"skipVersion('"+ versionInfo[0] +"');\" style=\"color:#66ccff;cursor:hand;text-decoration:none\" href=\"#\">skip this one!</span>";
					}
					return ("<center>"+msg+"</center>");
				}
			
			}
		}
	}catch(err){ }
	
		return null;
}

function skipVersion(v){
	System.Gadget.Settings.writeString("SkipVersion", v);
	RefreshPrayerTimes();
}

// Returns true if currentV < latestV
// Parameters are in x.x.x.x format
function isOldVersion(currentV, latestV){
	vv1 = currentV.split(".");
	vv2 = latestV.split(".");
	if(vv1.length != vv2.length && vv1.length != 4) return false;
	var vvv1 = 1000000 * parseInt(vv1[0]) + 10000 * parseInt(vv1[1]) + 100 * parseInt(vv1[2]) + 1 * parseInt(vv1[3]);
	var vvv2 = 1000000 * parseInt(vv2[0]) + 10000 * parseInt(vv2[1]) + 100 * parseInt(vv2[2]) + 1 * parseInt(vv2[3]);
	if(vvv2 > vvv1){
			return true;
	}
	return false;
}

// formats the location based on the informaiton provided
function formatLocation(vcity, vstate, vcountry){
	if(System.Gadget.Settings.readString("UseCustomLocation") == 'True'){
		loc = "<b>Prayer Times</b>";
	}else{
		loc = vcity.replace("_"," ") + ", ";
		if(vstate != '') loc += vstate.replace("_"," ");
		else loc += vcountry.replace("_"," ");
	}
	return (loc);
}

function displayMessage(msg){
	clearTimeout(toggleTimer);
	document.getElementById("mainPage").style.display = 'none'; // Hide the prayertimes table.
	document.getElementById("page2").style.display = 'none'; // Hide the second page.
	document.getElementById("msg").style.display = '';
	document.getElementById("msg").innerHTML = msg;
}

function toggleMsg(){
	document.getElementById("msg").style.display = 'none';
	document.getElementById("page2").style.display = 'none'; // Hide the second page
	document.getElementById("mainPage").style.display = ''; // Hide the prayertimes table.
	setTimeout("showAlarm=true;", 1000*60*2);
	startToggling();
}

// Checks periodically to emphasize the next prayer and to play Azan when due.
function doPeriodicCheck(){
	nextPrayerIndex = getNextPrayerIndex();
	
	var now = new Date(); now.setSeconds(0); now.setMilliseconds(0); 
	nextPrayerTime = getPrayerAsDate(nextPrayerIndex);
	if(nextPrayerTime){
		if (nextPrayerTime.toTimeString() == now.toTimeString()){
			//Play Azan for nextPrayerIndex, which is the current prayer time.
			playAzan(nextPrayerIndex);
		}
	
		// Check Alarms
		var timeBefore = System.Gadget.Settings.readString("Prayer"+nextPrayerIndex+"_Before_Alarm");
		if(timeBefore != -1 && nextPrayerIndex != 1 && showAlarm){
			var d = new Date(nextPrayerTime.valueOf()-(timeBefore*60*1000));
			if(d.toTimeString() == now.toTimeString()){
				showAlarm = false;
				displayMessage("<b>Get ready!</b><br>"+prayerNames[nextPrayerIndex]+" prayer is due soon!<br>Have you made wadu?<br><br><center><input type=\"button\" value=\" OK \" onclick=\"javascript:toggleMsg();\"></center>");
				System.Shell.execute("sidebar.exe"); // brings the sidebar to front
				playAlarm('before');
				setTimeout("toggleMsg()", 1000*60*2);
			}
		}
		
		currentPrayerIndex = nextPrayerIndex - 1;
		if(currentPrayerIndex < 0) currentPrayerIndex = 5;
		var timeAfter = System.Gadget.Settings.readString("Prayer"+currentPrayerIndex+"_After_Alarm");
		if(timeAfter != -1 && currentPrayerIndex != 1 && showAlarm){
			var pt = getPrayerAsDate(currentPrayerIndex);
			var d = new Date(pt.valueOf()+(timeAfter*60*1000));
			//document.getElementById("remaingTimePrayer").innerHTML = d;
			if(d.toTimeString() == now.toTimeString()){
				showAlarm = false;
				displayMessage("<b>Remember!</b><br>Time for "+prayerNames[currentPrayerIndex]+" prayer has come.<br>Don't delay your prayer!<br><br><center><input type=\"button\" value=\" OK \" onclick=\"javascript:toggleMsg();\"></center>");
				System.Shell.execute("sidebar.exe"); //Brings the sidebar to front
				playAlarm('after');
				setTimeout("toggleMsg()", 1000*60*2);
			}
		}
	
		// Calcualte and update remaining time
		updateRemainingTime();
	}
	// Emphasize nextPrayerIndex
	emphasizePrayer(nextPrayerIndex);
	
	setTimeout("doPeriodicCheck()", 1000*20); // check every 20 sec.
}

function updateRemainingTime(){
	now = new Date(); now.setSeconds(0); now.setMilliseconds(0);
	var p1
	var p2;
	currentPrayerIndex = nextPrayerIndex - 1;
	if(currentPrayerIndex < 0) currentPrayerIndex = 5;
	currentPrayerTime = getPrayerAsDate(currentPrayerIndex);

	p1 = currentPrayerTime;
	p2 = nextPrayerTime;
	if(nextPrayerIndex == 0){
		if(now.getHours() > 12){ // If the next prayer is Fajer and time is afternoon (night) then this the Fajr of the next day.
			p2 = new Date(nextPrayerTime.valueOf() + (1000*60*60*24));
		}else{
			p1 = new Date(currentPrayerTime.valueOf() - (1000*60*60*24));
		}
	}
	var d = Math.abs(p2.valueOf() - now.valueOf());
	rh = Math.floor(d/(1000*60*60)); 
	rm = Math.ceil((d-(rh*1000*60*60))/(1000*60));
	if(rh < 10) {rh = "0"+rh;}
	if(rm < 10) {rm = "0"+rm;}
	

	currentProgress = interpolateIndex(0, 99, p1, p2);
	currentIndex = Math.floor(currentProgress * remainingTimeColors.length / 100);
	currentWaitTimeIndex = Math.floor(currentProgress * waitTimes.length / 100);
	progressBar.style.height = Math.floor(currentProgress * 97 / 100);
	progressBar.style.backgroundColor = remainingTimeColors[currentIndex];
	document.getElementById("timeRemaining").innerHTML = rh + ":" + rm;
	document.getElementById("timeRemaining").style.color = remainingTimeColors[currentIndex];
	document.getElementById("remaingTimePrayer").innerHTML = prayerNames[nextPrayerIndex];
}

function updateRemainingTime11(){
	now = new Date(); now.setSeconds(0); now.setMilliseconds(0);
	var p1
	var p2;
	currentPrayerIndex = nextPrayerIndex - 1;
	if(currentPrayerIndex < 0) currentPrayerIndex = 5;
	currentPrayerTime = getPrayerAsDate(currentPrayerIndex);

	
	if(nextPrayerIndex == 0){
		if(now.getHours() > 12){ // If the next prayer is Fajer and time is afternoon (night) then this the Fajr of the next day.
			p1 = currentPrayerTime;
			p2 = new Date(nextPrayerTime.valueOf() + (1000*60*60*24));
			op = "1";
		}else{
			p1 = new Date(currentPrayerTime.valueOf() - (1000*60*60*24));
			p2 = nextPrayerTime;
			op = "2";
		}
	}
	var d = Math.abs(pt.valueOf() - now.valueOf());
	rh = Math.floor(d/(1000*60*60)); 
	rm = Math.ceil((d-(rh*1000*60*60))/(1000*60));
	if(rh < 10) {rh = "0"+rh;}
	if(rm < 10) {rm = "0"+rm;}
	
	document.getElementById( "hijriDate" ).innerHTML = op;

	currentProgress = interpolateIndex(0, 99, p1, p2);
	currentIndex = Math.floor(currentProgress * remainingTimeColors.length / 100);
	currentWaitTimeIndex = Math.floor(currentProgress * waitTimes.length / 100);

	progressBar.style.height = Math.floor(currentProgress * 97 / 100);
	progressBar.style.backgroundColor = remainingTimeColors[currentIndex];
	
	document.getElementById("timeRemaining").innerHTML = rh + ":" + rm;
	document.getElementById("timeRemaining").style.color = remainingTimeColors[currentIndex];
	
	document.getElementById("remaingTimePrayer").innerHTML = prayerNames[nextPrayerIndex];
}

function interpolateIndex(minIndex, maxIndex, currentTime, nextTime){
	var now = new Date();
	var a = (nextTime.valueOf()-now.valueOf());
	var b = (maxIndex-minIndex);
	var c = (nextTime.valueOf()-currentTime.valueOf());
	var d = Math.ceil(maxIndex - ( (a*b)/c ));
	if(d < minIndex) d = minIndex;
	if(d > maxIndex) d = maxIndex;
	return d;
}

function emphasizePrayer(prayerIndex){
	document.getElementById( ("prayer"+prayerIndex) ).parentElement.style.color='#66ccff';
	document.getElementById( ("prayer"+prayerIndex) ).parentElement.style.fontWeight='bold';
	if(lastEmphasized >=0 && lastEmphasized != prayerIndex){
		document.getElementById( ( "prayer" + lastEmphasized ) ).parentElement.style.color='white';
		document.getElementById( ("prayer"+lastEmphasized ) ).parentElement.style.fontWeight='normal';
	}
	lastEmphasized = prayerIndex;
}

function playAlarm(alarmType){
	if(System.Gadget.Settings.readString("AlarmsEnbled") == "True"){
		// alarmType can be 'after' or 'before' the currnetPrayerIndex
		var alarmFile = "http://www.loayassaf.com/PrayerTimes/getAlarm.php5";
	
		if(currentPrayerIndex == 0 && System.Gadget.Settings.readString("Morning_Azkar_Enabled") == "True" && alarmType == 'after'){
			alarmFile = "http://www.loayassaf.com/PrayerTimes/getMedia.php5?file=morningazkar";
		}else if(currentPrayerIndex == 3 && System.Gadget.Settings.readString("Evening_Azkar_Enabled") == "True" && alarmType == 'after'){
			alarmFile = "http://www.loayassaf.com/PrayerTimes/getMedia.php5?file=eveningazkar";
		} 
	
		playSoundFile(alarmFile, "65");
	}
}

function playAzan(prayerIndex){
	var availableAzans = new Array("bahrain", "brunei", "jordan", "egypt", "kuwait", "madina", "malasyia", "mecca", "qods", "sudan","tunisia","turkey","surprise");

	if(prayerIndex == 0) FajrNextDay = false;
	if(prayerIndex != 1 && lastAzanPlayed != prayerIndex){ // Not Sunrise and not played before.
		if(System.Gadget.Settings.readString("Prayer"+prayerIndex+"_Azan_Enabled") == "True"){
			var azanFile = System.Gadget.Settings.readString("AzanFile");
			if(prayerIndex == 0) azanFile = System.Gadget.Settings.readString("FajrAzanFile");
			
			// If Azan is random
			if(System.Gadget.Settings.readString("AzanOption") == "random"){
				var i = Math.floor(Math.random( ) * 1000) % availableAzans.length; //pick a random index
				if(i>=availableAzans.length) i = availableAzans.length-1; // make sure that it's within the limit
				var azanFile = 'http://www.loayassaf.com/PrayerTimes/getMedia.php5?file=' + availableAzans[i]; // Select the random azan
				if(prayerIndex == 0) azanFile = azanFile + 'fajr'; // fix it for Fajr
			}
			
			var vol = System.Gadget.Settings.readString("AzanVolume");
			lastAzanPlayed = prayerIndex;
			playSoundFile(azanFile, vol);
		}
	}
}

function playSoundFile(f, vol){
	if (player){
		player.settings.volume = vol;
		player.URL = f;
		player.controls.play();
		//stopSoundButton.filters.item("DXImageTransform.Microsoft.Alpha").opacity = 40;
		//stopSoundButton.style.display = '';
	}
}

function getNextPrayerIndex(){
	var now = new Date(); now.setSeconds(0); now.setMilliseconds(0);
	if(prayers != null){
		for(i=0;i<prayers.length;i++){
			prayerTime = getPrayerAsDate(i);
			if(now.valueOf() <= prayerTime.valueOf()) {
				nextPrayerIndex = i ;
				break;
			}
		}
		if(i == prayers.length){ // we passed Isha 
			nextPrayerIndex = 0;
		}

		return nextPrayerIndex;
	} 
}


function getPrayerAsDate(prayerIndex){
	if(prayers!= null){
		var hhmm = prayers[prayerIndex].split(":");
	
		if(prayerIndex > 2){ // Asr, Maghrib and Isha
			hhmm[0] = parseInt(hhmm[0]) + 12; // convert to 24hrs
		}else {
			if(prayerIndex == 2){ // Duhr
				if(hhmm[0] < 5) {
					hhmm[0] = parseInt(hhmm[0]) + 12; // convert to 24hrs
				}
			}
		}

		var now = new Date();
		var prayerTime = new Date(now.getYear(), now.getMonth(), now.getDate(), hhmm[0], hhmm[1], 0);

		return prayerTime;
	}
}

function stopSound(){
	if(player){
		player.controls.stop();
	}
	//stopSoundButton.style.display = 'none';
}

function setHijriDate(dt){
	var hd = dt.split("/");
	var y = hd[0];
	var m = hd[1];
	var d = parseInt(hd[2])+parseInt(System.Gadget.Settings.readString("HijriAdjustment"));
	if(d > 29){ // date cannot be more than 29
		d = d - 29;
		m = m + 1;
		if(m > 12){
			m = m - 12;
			y = y + 1;
		}
	}
	if(d < 1){ // date cannot be less than 1
		d = d + 29;
		m = m - 1;
		if(m < 1){
			m = m + 12;
			y = y - 1;
		}
	}
	var months = Array("Muharram", "Safar", "Rabi I", "Rabi II", "Jumada I", "Jumada II", "Rajab", "Shaban", "Ramadan", "Shawal", "Zul-Qidah", "Zul-Hijjah");
	document.getElementById( "hijriDate" ).innerHTML = d + "-" + months[m-1] + "-" + y;
}

function setQibla(q){
	document.getElementById( "qiblaAngle" ).innerHTML = (Math.round(q*10)/10) + "&deg; from North";
}

function increaseOpacity(){
	if(parseInt(stopSoundButton.filters.item("DXImageTransform.Microsoft.Alpha").opacity) < 90){
		stopSoundButton.filters.item("DXImageTransform.Microsoft.Alpha").opacity += 5;
		setTimeout("increaseOpacity()", 100);
	}
}

function decreaseOpacity(){
	if(parseInt(stopSoundButton.filters.item("DXImageTransform.Microsoft.Alpha").opacity) > 25){
		stopSoundButton.filters.item("DXImageTransform.Microsoft.Alpha").opacity -= 5;
		setTimeout("decreaseOpacity()", 100);
	}
}